<id>
Power Hide Y2.1
</id>

<version>
1.1
</version>

<mod info>
This mod allows power users to hide single messages within a thread (upto their own level).
This mod will not mask hidden messages in the totals but it will prevent users to see messages marked with a higher visibility level then their own.
So before anyone starts complaining the message index tells him 10  replies and he sees only 6..... this means there is stuff hidden in the thread not ment for your eyes.
Application could be to make hidden staff notes in a users thread if needed (like privacy sensitive data not ment for the public eye but useful to keep inside a thread.

Usage
In the message post area only power users will have an extra radiobutton set below the message field which allows them to set view level up to their own level.
This means a moderator can only restrict view up to moderator level (basically only hiding it from members and guests, while a Global Moderator can hide a message
for moderators too, and an administrator can hide a message for everyone below the rank of Administrator.
 
Installation
Apply the mod, upload the changed YaBBC.pl, Display.pl, ModifyMessage.pl, Main.lng,Search.pl, Display.template and Post.pl.

IMPORTANT !!
This mod adds a specific tag to the first line of a message thread ([admin only], [gmod only], [mod only] and [member only]) which remains hidden throughout
the boards usage, and which determines the visibility of the message it is in.
If you remove this mod ALL hidden messages will be revealed !!

THIS ALSO MEANS THAT IF YOU UPGRADE TO YABB2.2 YOU NEED TO HAVE THIS MOD INSTALLED IN ORDER TO REMAIN HIDDEN STUFF TO BE HIDDEN !!!
The mod will probably install in YaBB2.2 also, but a YaBB2.2 version will be available asap.

Version History
1.0
First release

1.0a
- Fixed mod closing tag
- Added Printpage and Recent Posts code

1.0b
- Changed Recent.pl and Search.pl to be not confusing (thanks MF-B)

1.0c
- Added check on User Recent post and Thread Summary (Thanks Larian)
- added extra text string 5a for our german friends

1.1
- Fixed ranking order if Global Moderators were also assigned Moderator on boards.
- Made mod final
</mod info>

<author>
Spikecity
</author>

<homepage>
http://www.yabb.nl
</homepage>

<edit file>
Sources/YaBBC.pl
</edit file>

<search for>
sub DoUBBC {
</search for>

<add after>
	## Determine visibility level and strip off the flags from the message body ##
	$readlevel = 0;
	if ($message =~ /^\[admin only\]/){
		$readlevel = 5;
		$message =~ s~\[admin only\]~~;
	} elsif ($message =~ /^\[gmod only\]/){
		$readlevel = 4;
		$message =~ s~\[gmod only\]~~;
	} elsif ($message =~ /^\[mod only\]/){
		$readlevel = 3;
		$message =~ s~\[mod only\]~~;
	} elsif ($message =~ /^\[member only\]/){
		$readlevel = 1;
		$message =~ s~\[member only\]~~;
	} else {
		$readlevel = 0;
	}

</add after>

<edit file>
Sources/Printpage.pl
</edit file>

<search for>
	# Split the threads up so we can print them.
	foreach $thread (@threads) {
		($threadtitle, $threadposter, $trash, $threaddate, $trash, $trash, $trash, $trash, $threadpost) = split(/\|/, $thread);
</search for>

<add after>

		## Determine visibility level and strip off the flags from the message body ##
		$readlevel = 0;
		if ($threadpost =~ /^\[admin only\]/){
			$readlevel = 5;
			$threadpost =~ s~\[admin only\]~~;
		} elsif ($threadpost =~ /^\[gmod only\]/){
			$readlevel = 4;
			$threadpost =~ s~\[gmod only\]~~;
		} elsif ($threadpost =~ /^\[mod only\]/){
			$readlevel = 3;
			$threadpost =~ s~\[mod only\]~~;
		} elsif ($threadpost =~ /^\[member only\]/){
			$readlevel = 1;
			$threadpost =~ s~\[member only\]~~;
		} else {
			$readlevel = 0;
		}
		if (($iamguest && $readlevel > 0) || (!$iamguest && !$iammod && !$iamgmod && !$iamadmin && $readlevel > 2) || (($iammod && !$iamgmod && !$iamadmin) && $readlevel > 3) || ($iamgmod && $readlevel > 4)){ 
			next; 		## skip to next message if visibility is restricted
		}

</add after>

<edit file>
Sources/Post.pl
</edit file>

<search for>
	# this is the message area.
</search for>

<add before>

	## build readability selector and remove tag ##
	if ($message =~ /^\[admin only\]/){
		$readlevel = 5;
		$message =~ s~\[admin only\]~~;
	} elsif ($message =~ /^\[gmod only\]/){
		$readlevel = 4;
		$message =~ s~\[gmod only\]~~;
	} elsif ($message =~ /^\[mod only\]/){
		$readlevel = 3;
		$message =~ s~\[mod only\]~~;
	} elsif ($message =~ /^\[member only\]/){
		$readlevel = 1;
		$message =~ s~\[member only\]~~;
	} else {
		$readlevel = 0;
	}
	$rch{$readlevel} = qq~ checked="checked"~;

	if($iammod || $iamgmod || $iamadmin){
		$readable = qq~$read_txt{'visible_for'} 
		<input type="radio" name="readflag" id="readflag" value="0"$rch{0} /> $read_txt{'0'}&nbsp;&nbsp;
		<input type="radio" name="readflag" id="readflag" value="1"$rch{1} /> $read_txt{'1'}&nbsp;&nbsp;
		<input type="radio" name="readflag" id="readflag" value="3"$rch{3} /> $read_txt{'3'}&nbsp;&nbsp;
	~;
	}
	if($iamgmod || $iamadmin){
		$readable .= qq~<input type="radio" name="readflag" id="readflag" value="4"$rch{4} /> $read_txt{'4'}&nbsp;&nbsp;
	~;
	}
	if($iamadmin){
		$readable .= qq~<input type="radio" name="readflag" id="readflag" value="5"$rch{5} /> $read_txt{'5'}
	~;
	}

</add before>

<search for>
       <td class="windowbg" width="77%"><input type="checkbox" name="ns" value="NS"$nscheck /> <span class="small"> $post_txt{'277'}</span><br /><br /></td>
</search for>

<replace>
        <td class="windowbg" width="77%"><input type="checkbox" name="ns" value="NS"$nscheck /> <span class="small"> $post_txt{'277'}</span><br />
	<span class="small">$readable</span><br /><br /></td>
</replace>

<search for>
	# Permission checks for posting.
</search for>

<add before>

	## determine the visibility flag to be inserted in the message body ##
	$readflag  = $FORM{'readflag'};
	if ($readflag == 5){ 
		$readtag = qq~[admin only]~;
	} elsif ($readflag == 4){ 
		$readtag = qq~[gmod only]~;
	} elsif ($readflag == 3){ 
		$readtag = qq~[mod only]~;
	} elsif ($readflag == 1){ 
		$readtag = qq~[member only]~;
	} elsif ($readflag == 0){ 
		$readtag = qq~~;
	}
	## and glue the tag in front of the message ##
	$message = "$readtag$message";

</add before>

<search for>
			$parseflash  = 0;
			$message     = &Censor($message);
</search for>

<add after>

			## determine if it is a restricted view message in summary or not ##
			if ($message =~ /^\[admin only\]/) { $readlevel = 5; }
			elsif ($message =~ /^\[gmod only\]/) { $readlevel = 4; }
			elsif ($message =~ /^\[mod only\]/) { $readlevel = 3; }
			elsif ($message =~ /^\[member only\]/){ $readlevel = 1; }
			else { $readlevel = 0; }
			if (($iamguest && $readlevel > 0) || (!$iamguest && !$iammod && !$iamgmod && !$iamadmin && $readlevel > 2) || (($iammod && !$iamgmod && !$iamadmin) && $readlevel > 3) || ($iamgmod && $readlevel > 4)){ 
				next;
			}

</add after>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
						for ($c = 0; $c < @messages; $c++) {
							chomp $messages[$c];
							($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns) = split(/\|/, $messages[$c]);
</search for>

<add after>

							## determine if it is a restricted view message in recent or not ##
							if ($message =~ /^\[admin only\]/) { $readlevel = 5; }
							elsif ($message =~ /^\[gmod only\]/) { $readlevel = 4; }
							elsif ($message =~ /^\[mod only\]/) { $readlevel = 3; }
							elsif ($message =~ /^\[member only\]/){ $readlevel = 1; }
							else { $readlevel = 0; }
							if (($iamguest && $readlevel > 0) || (!$iamguest && !$iammod && !$iamgmod && !$iamadmin && $readlevel > 2) || (($iammod && !$iamgmod && !$iamadmin) && $readlevel > 3) || ($iamgmod && $readlevel > 4)){ 
								next;
							}

</add after>



<edit file>
Sources/ModifyMessage.pl
</edit file>

<search for>
	&fatal_error($post_txt{'78'}) unless ($message);
	$mess_len = $message;
</search for>

<add before>

	## determine the visibility flag to be inserted in the message body ##
	$readflag  = $FORM{'readflag'};
	if ($readflag == 5){ 
		$readtag = qq~[admin only]~;
	} elsif ($readflag == 4){ 
		$readtag = qq~[gmod only]~;
	} elsif ($readflag == 3){ 
		$readtag = qq~[mod only]~;
	} elsif ($readflag == 1){ 
		$readtag = qq~[member only]~;
	} elsif ($readflag == 0){ 
		$readtag = qq~~;
	}
	## and glue the tag in front of the message ##
	$message = "$readtag$message";

</add before>

<edit file>
Sources/Search.pl
</edit file>

<search for>
		($board, $tnum, $msgnum, $tusername, $tname, $msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns, $tstate) = @{ $data{ $messages[$i] } };
		$displayname = $mname;
</search for>

<add after>

		## determine if it is a restricted view message or not ##
		if ($message =~ /^\[admin only\]/) { $readlevel = 5; }
		elsif ($message =~ /^\[gmod only\]/) { $readlevel = 4; }
		elsif ($message =~ /^\[mod only\]/) { $readlevel = 3; }
		elsif ($message =~ /^\[member only\]/){ $readlevel = 1; }
		else { $readlevel = 0; }
		if (($iamguest && $readlevel > 0) || (!$iamguest && !$iammod && !$iamgmod && !$iamadmin && $readlevel > 2) || (($iammod && !$iamgmod && !$iamadmin) && $readlevel > 3) || ($iamgmod && $readlevel > 4)){ 
			next;
		}

</add after>

<edit file>
Sources/Recent.pl
</edit file>

<search for>
			chomp $message;

			if ($message) {
</search for>

<add after>

				## determine if it is a restricted view message or not ##
				if ($message =~ /^\[admin only\]/) { $readlevel = 5; }
				elsif ($message =~ /^\[gmod only\]/) { $readlevel = 4; }
				elsif ($message =~ /^\[mod only\]/) { $readlevel = 3; }
				elsif ($message =~ /^\[member only\]/){ $readlevel = 1; }
				else { $readlevel = 0; }
				if (($iamguest && $readlevel > 0) || (!$iamguest && !$iammod && !$iamgmod && !$iamadmin && $readlevel > 2) || (($iammod && !$iamgmod && !$iamadmin) && $readlevel > 3) || ($iamgmod && $readlevel > 4)){ 
					next;
				}

</add after>

<search for>
				if ($mess[$ii]) {
					($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns) = split(/\|/, $mess[$ii]);
					$mtime = $mdate;
</search for>

<add after>

					## determine if it is a restricted view message or not ##
					if ($message =~ /^\[admin only\]/) { $readlevel = 5; }
					elsif ($message =~ /^\[gmod only\]/) { $readlevel = 4; }
					elsif ($message =~ /^\[mod only\]/) { $readlevel = 3; }
					elsif ($message =~ /^\[member only\]/){ $readlevel = 1; }
					else { $readlevel = 0; }
					if (($iamguest && $readlevel > 0) || (!$iamguest && !$iammod && !$iamgmod && !$iamadmin && $readlevel > 2) || (($iammod && !$iamgmod && !$iamadmin) && $readlevel > 3) || ($iamgmod && $readlevel > 4)){ 
						next;
					}

</add after>

<edit file>
Sources/Display.pl
</edit file>

<search for>
			&DoUBBC;
		}
		&wrap2;
		&ToChars($message);
</search for>

<add after>

		## check if the message is visible to the user ##
		if (($iamguest && $readlevel > 0) || (!$iamguest && !$iammod && !$iamgmod && !$iamadmin && $readlevel > 2) || (($iammod && !$iamgmod && !$iamadmin) && $readlevel > 3) || ($iamgmod && $readlevel > 4)){ 
			$counter++;	## increase message count to maintain correct reference
			$endpage++;	## compensate page length for hidden messages
			next; 		## skip to next message if visibility is restricted
		}

</add after>

<search for>
		$posthandelblock =~ s/<yabb quote>/$template_quote/g;
		$posthandelblock =~ s/<yabb modify>/$template_modify/g;
</search for>

<add before>

		## set a marker in the message header on visibility if restricted ##
		if ($readlevel > 0){ $readable = qq~$read_txt{'only_visible_for'}$read_txt{$readlevel}~;
			if ($readlevel < 5){ $readable .= qq~ $read_txt{'and_up'}~; }
			$readable .= qq~$read_txt{'5a'}<br />~;
		} else { $readable = ""; }

</add before>

<search for>
		$outblock =~ s/<yabb images>/$imagesdir/g;
		$outblock =~ s/<yabb messageoptions>/$msgcontrol/g;
</search for>

<add before>

		## add the visibility flag in the template to show the restricted message ##
		$outblock =~ s/<yabb readflag>/$readable/g;

</add before>

<edit file>
Templates/default/Display.template
</edit file>

<search for>
			<span class="small"><b><yabb replycount></b><yabb msgdate></span>
</search for>

<replace>
			<span class="small"><font color="red"><yabb readflag></font><b><yabb replycount></b><yabb msgdate></span>
</replace>

<edit file>
Languages/Deutsch/Main.lng
</edit file>

<search for>
1;
</search for>

<add before>

%read_txt = (
'visible_for' => "Diese Nachricht ist sichtbar fr: ",
'only_visible_for' => "Diese Nachricht ist nur fr ",
'and_up' => "und hher ",
'0' => "Jeden",
'1' => "Mitglieder",
'3' => "Moderatoren",
'4' => "Global Moderatoren",
'5' => "Administratoren",
'5a' => "sichtbar.",
);

</add before>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$powerhide = "YaBB Power Hide 1.1 GE|Ron@Spikecity|Allows hiding of single messages in different levels|V1.1|March 31th 2007";
	push (@installed_mods, "$powerhide");
</add before>
